package circularlist;

public interface CircularList<E> {

	/** get the element at index i % size(). */
	E get(int i);

	/**
	 * return the first index of the object o in the circular list, -1 if the object
	 * is not present.
	 * 
	 * @throws ObjectMissingException
	 */
	int indexOf(Object o) throws ObjectMissingException;

	/** number of elements contained in the circular list. */
	int size();

	E nextElement();

	boolean add(E element);

	void add(int i, E element);

	void addAll(CircularListImpl<? extends E> cl);

}