package circularlist;

class UnmodifiableCircularList<E> implements CircularList<E> {

	private CircularList<E> delegate;
	
	UnmodifiableCircularList(CircularList<E> cl) {
		delegate = cl;
	}
	
	@Override
	public E get(int i) {
		return delegate.get(i);
	}

	@Override
	public int indexOf(Object o) throws ObjectMissingException {
		return delegate.indexOf(o);
	}

	@Override
	public int size() {
		return delegate.size();
	}

	@Override
	public E nextElement() {
		return delegate.nextElement();
	}

	@Override
	public boolean add(E element) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void add(int i, E element) {
		throw new UnsupportedOperationException();		
	}

	@Override
	public void addAll(CircularListImpl<? extends E> cl) {
		throw new UnsupportedOperationException();		
	}
	
	public boolean equals(Object o) {
		return delegate.equals(o);
	}

	public int hashCode() {
		return delegate.hashCode();
	}
	
	public String toString() {
		return delegate.toString();
	}
}
